const CI = Components.interfaces;
const CC = Components.classes;

var Chooser = {
  init: function() {
    this.dialog = document.documentElement;
   
    this.params = window.arguments[0];
    this.params.choosenDir = this.params.initialDir;
    
    this.dialog.setAttribute("title", this.params.title);
    document.getElementById("destLabel").setAttribute("value",
      this.destFolderLabel = gFlashGotService.getString("ph.FOLDER")
    );
    if (this.params.choosenDir) {
      this.sync();
    } else {
      this.browse();
    }
  },
  
  sync: function() {
    var t = document.getElementById("dest");
    var d = this.params.choosenDir;
    if (d && t.value != d.path) {
      t.value = d.path;
    } 
    this.dialog.getButton("accept").setAttribute("disabled", !d);
  },
  
  folderChanged: function(t) {
    var path = t.value;
    this.params.choosenDir = null;      
    try {
      var d = CC["@mozilla.org/file/local;1"].createInstance(CI.nsILocalFile);
      d.initWithPath(t.value);
      if (!d.exists() || d.isDirectory())
        this.params.choosenDir = d;      
    } catch(e) {
    }
    this.sync();
  },

  browse: function() {
    const fp = CC["@mozilla.org/filepicker;1"].createInstance(CI.nsIFilePicker);
   
    fp.init(window, this.params.title + " - " + this.destFolderLabel, CI.nsIFilePicker.modeGetFolder);
    var d = this.params.choosenDir || this.params.initialDir;
    try {
      if (d && (d.exists() || (d = d.parent).exists()) && d.isDirectory()) {
        fp.displayDirectory = d;
      }
    } catch (ex) { gFlashGotService.log(ex); }
    
    fp.appendFilters(CI.nsIFilePicker.filterAll);
    
    if (fp.show() == CI.nsIFilePicker.returnOK) {
      this.params.choosenDir = fp.file;
      this.sync();
    }
  },
  
  accept: function() {
    // create directory if it does not exist
    var d = this.params.choosenDir;
    if (d && !d.exists()) {
      var permissions = d.parent.exists() ? d.parent.permissions : 0600;
      try {
        d.create(CI.nsIFile.DIRECTORY_TYPE, permissions);
      } catch(e) {
      }
    }
  },
  cancel: function() {
    this.params.choosenDir = null;
  }
}